=== debian/changelog ===
onedpl (2022.9.0-0ubuntu5~26.04) resolute; urgency=medium

  * Initial package upload (LP: #2130191)
    - d/watch: upgrade to version 5.
    - d/copyright: fix lintian messages and make it conform to
      latest source code level.

 -- Will French <will.french@canonical.com>  Fri, 13 Feb 2026 16:48:53 -0600

onedpl (2022.9.0-0ubuntu4~26.04) resolute; urgency=medium

  * Initial package upload (LP: #2130191)
    - d/copyright: prefer Expat over MIT and other lrc fixes.

 -- Will French <will.french@canonical.com>  Tue, 10 Feb 2026 14:48:43 -0600

onedpl (2022.9.0-0ubuntu3~26.04) resolute; urgency=medium

  * Initial package upload (LP: #2130191)
    - d/copyright: format with max 78 column width.

 -- Will French <will.french@canonical.com>  Mon, 02 Feb 2026 13:25:19 -0600

onedpl (2022.9.0-0ubuntu2~26.04) resolute; urgency=medium

  * Initial package upload (LP: #2130191)
    - d/copyright: add files flagged by licensecheck -r.

 -- Will French <will.french@canonical.com>  Mon, 02 Feb 2026 11:16:54 -0600

onedpl (2022.9.0-0ubuntu1~26.04) resolute; urgency=medium

  * Initial package upload (LP: #2130191)

 -- Will French <will.french@canonical.com>  Mon, 12 Jan 2026 15:26:16 -0600
