=== debian/tests/control ===
Tests: reduce-segment, binary-search, dpl-sortdouble
# tests all require the DPC++ compiler to build samples
Depends: @, clang-dpcpp-21
Restrictions: allow-stderr
