=== debian/watch ===
version=5
opts="repack,uversionmangle=s/-release$//" \
  https://github.com/uxlfoundation/oneDPL/tags \
  (?:.*?/)?oneDPL-(\d+\.\d+\.\d+)-release\.tar\.gz debian uupdate
